![Discord](https://img.shields.io/discord/624100926054989834?color=red&label=discord&style=social)
![Commit activity](https://img.shields.io/github/commit-activity/m/halotroop/litecraft)
![Issues](https://img.shields.io/github/issues/halotroop/LiteCraft)

# LiteCraft
A lightweight voxel game engine built on the [Ginger3D game engine created by hYdos](https://github.com/halotroop/Ginger3D). <br/>
I ([halotroop2288](https://github.com/halotroop2288)) created this project because of the drama in the Minecraft modding community around [mappings](https://fabricmc.net/wiki/rules#mapping) and the consensus that Mojang does not write good code or make very good or popular decisions regarding the direction of the game. (For instance promising a full native modding API for years, but instead giving us "datapacks", or [choosing not to implement some features because "they don't add to the experience," but adding other features regardless of that rule](https://feedback.minecraft.net/hc/en-us/articles/360005029872-Previously-Considered-Suggestions)) <br/>
I feel it is very preferable to have our own codebase than work around one that everyone seems to dislike, which is always changing, and forcing us to adapt.

#### Goals:
 - Create an open-source alternative to the most popular game in the world, Minecraft.
 - Keep the game's code as small as possible, utilizing libraries above original code as often as possible.
 
#### Planned Features
 1. Feature parity with [Minecraft](https://www.minecraft.net), such as:
   - Gameplay: crafting, combat, and exploration, sandbox building
   - World: Procedural generation, multiple dimensions
 2. Extra features for modders,
   - Full access to modify source code and submit pull requests to be adopted into the main game
   - Modular structure to allow for easy additions of blocks, items, effects, shaders, etc.

#### Stretch goals
 1. Minecraft: Java Edition server cross-compatability (if LiteCraft ever gains multiplayer)
 2. Full support of Fabric Mod Loader (It should already support all Java games by default, but sometimes has dependency issues)
 3. Full support of other Minecraft mod loaders (this would be the job of their devs, not us.)

#### Stale
Yes, this project is getting stale. The code hasn't been worked on for some time by the main team, as we have mostly disbanded. If you would like to see this project continue, contribute to the game! [Submit a pull request](https://github.com/halotroop/LiteCraft/compare), or [join the Discord](https://halotroop.com/discord) if you want to become a memeber the main team. All will be considered.

# LICENSE
This project is licensed under the GNU General Public License Version 3.0 <br/>
For details see [LICENSE](https://github.com/halotroop/LiteCraft/blob/master/LICENSE) <br/>
![GPLv3 or later](https://www.gnu.org/graphics/gplv3-or-later.png "GPLv3-plus Logo")
